﻿-- AlertFrame 
AlertFrame = CreateFrame("Frame"); 
AlertFrame:ClearAllPoints(); 
AlertFrame:SetHeight(100); 
AlertFrame:SetWidth(100); 
AlertFrame:SetPoint("CENTER", UIParent, "CENTER");
AlertFrame:SetScript("OnUpdate", function(self, elapsed)
	if (AlertFrame.Time < GetTime() - 3) then		
		local alpha = AlertFrame:GetAlpha()
		if (alpha ~= 0) then AlertFrame:SetAlpha(alpha - .05) end
		if (aplha == 0) then AlertFrame:Hide() end
	end
end
) 
AlertFrame:Hide(); 
AlertFrame.text = AlertFrame:CreateFontString(nil, "BACKGROUND", "PVPInfoTextFont"); 
AlertFrame.text:SetAllPoints(); 
AlertFrame.Time = 0;
  
function AlertMsg(message, color) 
	AlertFrame.text:SetText(message); 
	if color=="green" then
		AlertFrame.text:SetTextColor(0,1,0)
	elseif color == "red" then
		AlertFrame.text:SetTextColor(1,0,0)
	else 
		AlertFrame.text:SetTextColor(1,1,1)
	end
	AlertFrame:SetAlpha(1); 
	AlertFrame:Show(); 
	AlertFrame.Time = GetTime(); 
end
----------------------------------------------------------------------------------------------



-- Setup power bars' heights
function MSS_PowerFrame_OnLoad(self)
	local height = 20
	self.RageBar:SetHeight(height)
	self.EnergyBar:SetHeight(height)
	self.ManaBar:SetHeight(height)
	self.EclipseBar:SetHeight(height)	
	
	self.EclipseBar.Lunar:SetHeight(height)
	self.EclipseBar.LunarMask:SetHeight(height)
	self.EclipseBar.Solar:SetHeight(height)
	self.EclipseBar.SolarMask:SetHeight(height)
end


function RageBar_OnUpdate(self, elapsed)
	if GetShapeshiftFormID() == 5 then
		local currentChance = self:GetValue()
		local newChance = UnitPower("player", SPELL_POWER_RAGE)	
		if newChance - currentChance > 1 then
			self:SetValue(currentChance + 1)
		elseif newChance - currentChance <= 1  and newChance - currentChance > 0 then
			self:SetValue(newChance)
		elseif currentChance - newChance > 10 then
			self:SetValue(currentChance - 10)
		elseif currentChance - newChance > 0 and currentChance - newChance < 10 then
			self:SetValue(newChance)
		end 
		self.text:SetText(self:GetValue())
		local _, maxValue = self:GetMinMaxValues()
		self.spark:SetPoint("LEFT", self, "LEFT", self:GetValue()/maxValue*176 - 15, -1)
	else 
		self:SetValue(0)
		self.text:SetText(self:GetValue())
		self.spark:SetPoint("LEFT", self, "LEFT", - 15, -3)
	end	
end


function EnergyBar_OnUpdate(self, elasped)
	local currentChance = self:GetValue()
	local newChance = UnitPower("player", SPELL_POWER_ENERGY)	
	if newChance - currentChance > 10 then
		self:SetValue(currentChance + 10)
	elseif newChance - currentChance <= 10  and newChance - currentChance > 0 then
		self:SetValue(newChance)
	elseif currentChance - newChance > 10 then
		self:SetValue(currentChance - 10)
	elseif currentChance - newChance > 0 and currentChance - newChance < 10 then
		self:SetValue(newChance)
	end 
	self.text:SetText(self:GetValue())
	local _, maxValue = self:GetMinMaxValues()
	self.spark:SetPoint("LEFT", self, "LEFT", self:GetValue()/maxValue*176 - 15, -1)
end


function ManaBar_OnLoad(self) 			
	self:SetMinMaxValues(0, UnitPowerMax("player", SPELL_POWER_MANA))
	self:SetValue(UnitPower("player")) 
	self:SetStatusBarColor(0.0, 0.15 ,0.70)			
end


function ManaBar_OnUpdate(self, elasped)
	self:SetMinMaxValues(0, UnitPowerMax("player", SPELL_POWER_MANA))	
	local currentChance = self:GetValue()
	local newChance = UnitPower("player", SPELL_POWER_MANA)		
	self:SetValue(newChance)	
	local _, maxValue = self:GetMinMaxValues()
	self.spark:SetPoint("LEFT", self, "LEFT", newChance/maxValue*176 - 15, -3)
	self.text:SetText(newChance)
end


function EclipseBar_OnUpdate(self, elapsed)
	MSS_SolarMask:SetFrameLevel(100)
	MSS_LunarMask:SetFrameLevel(100)
	
	local newChance = UnitPower("player", SPELL_POWER_ECLIPSE)	
	local direction = GetEclipseDirection()	
	
	if newChance >= 0 then
		MSS_SolarMask:SetValue(newChance)
		MSS_LunarMask:SetValue(0)
	elseif newChance < 0 then
		MSS_LunarMask:SetValue(newChance)
		MSS_SolarMask:SetValue(0)
	end
	
	-- Set spark
	MSS_LunarMask.spark:SetPoint("LEFT", MSS_LunarMask, "LEFT", (100 + MSS_LunarMask:GetValue())/100*88 - 15, -3)
	MSS_SolarMask.spark:SetPoint("LEFT", MSS_SolarMask, "LEFT", MSS_SolarMask:GetValue()/100*88 - 15, -3)	
	
	if (newChance > 0 and direction == "moon") or self.nextToEclipse == 1 then -- Sun Eclipse
		SolarIconActive:Show()		
		SolarIconActive.pulse:Play()
	else 
		SolarIconActive:Hide()
	end
	
	if (newChance < 0 and direction == "sun") or self.nextToEclipse == -1 then -- Moon Eclipse
		LunarIconActive:Show()		
		LunarIconActive.pulse:Play()
	else 
		LunarIconActive:Hide()
	end
	
	if newChance < 0 then
		newChance = -newChance
	end
	if direction == "moon" then
		MSS_EclipseBar_Text:SetPoint("CENTER", self, "CENTER", -30,1)
		MSS_EclipseBar_Text:SetText("<"..newChance)
	elseif direction == "sun" then
		MSS_EclipseBar_Text:SetPoint("CENTER", self, "CENTER", 30,1)
		MSS_EclipseBar_Text:SetText(newChance..">")
	else
		MSS_EclipseBar_Text:SetPoint("CENTER", self, "CENTER", 0, 1)
		MSS_EclipseBar_Text:SetText("<"..newChance..">")
	end	
end


function EclipseBar_OnEvent(self, event, ...)
	local timeStamp, eventType, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags = select(1, ...)
	
	if sourceName == UnitName("player") then
	
			if eventType == "SPELL_CAST_START" then
				local spellId, spellName, spellSchool = select(12, ...)
				local auraType = select(15, ...)
				--MSS:showMsg(spellId .."-".. spellName)
				local power = UnitPower("player", SPELL_POWER_ECLIPSE)
				
				if spellId == 2912  then -- starfire
					if power >= 60 and GetEclipseDirection() == "sun" then
						MSS_EclipseBar_Text:SetTextColor(0,1,0)
						SolarIconActive:Show()
						self.nextToEclipse = 1
						AlertMsg("即将进蚀", "green")
					end
					
					if power >= -40 and power < -20 and GetEclipseDirection() == "sun" then
						MSS_EclipseBar_Text:SetTextColor(1,0,0)
						AlertMsg("即将出蚀", "red")
					end												
				end
				
				if spellId == 5176 then --wrath
					if power <= -70 and GetEclipseDirection() == "moon" then
						MSS_EclipseBar_Text:SetTextColor(0,1,0)
						LunarIconActive:Show()
						self.nextToEclipse = -1
						AlertMsg("即将进蚀","green")
					end
					
					if power <= 35 and power > 15 and GetEclipseDirection() == "moon" then
						MSS_EclipseBar_Text:SetTextColor(1,0,0)
						AlertMsg("即将出蚀", "red")
					end												
				end
				
				if spellId == 78674 then -- starsurge
					if power >= 60 and GetEclipseDirection() == "sun" then
						MSS_EclipseBar_Text:SetTextColor(0,1,0)						
						self.nextToEclipse = 1
						AlertMsg("即将进蚀","green")
					end
					if power <= -60 and GetEclipseDirection() == "moon" then
						MSS_EclipseBar_Text:SetTextColor(0,1,0)						
						
						self.nextToEclipse = -1
						AlertMsg("即将进蚀","green")
					end	
					if power >= -40 and power < -20 and GetEclipseDirection() == "sun" then
						MSS_EclipseBar_Text:SetTextColor(1,0,0)
						AlertMsg("即将出蚀","red")
					end
					if power <= 35 and power > 20 and GetEclipseDirection() == "moon" then
						MSS_EclipseBar_Text:SetTextColor(1,0,0)
						AlertMsg("即将出蚀", "red")
					end	
				end--starsurge				
			end--cast start
			
			if eventType == "SPELL_ENERGIZE" or eventType == "SPELL_CAST_FAILED" then
				MSS_EclipseBar_Text:SetTextColor(1,1,1)
				if self.nextToEclipse == -1 then
					self.nextToEclipse = 0
					LunarIconActive:Hide()
				elseif self.nextToEclipse == 1 then
					self.nextToEclipse = 0
					SolarIconActive:Hide()
				end
			end
	end	
end


-- Setup a combo orb
local function SetCombo(specId, combo, active, inCD)
	if active then
		if specId == 1 or specId == 4 then
			if inCD then
				combo:SetTexture("Interface/COMMON/Indicator-Yellow.blp")
			else
				combo:SetTexture("Interface/COMMON/Indicator-Green.blp")
			end
		elseif specId == 2 then
			combo:SetTexture("Interface/COMMON/Indicator-Yellow.blp")
		elseif specId == 3 then
			if inCD then
				combo:SetTexture("Interface/COMMON/Indicator-Yellow.blp")
			else 	
				combo:SetTexture("Interface/COMMON/Indicator-Red.blp")
			end
		end
	else 
		combo:SetTexture("Interface/COMMON/Indicator-Gray.blp")
	end
end


function MSS_ComboFrame_OnUpdate(self, elapsed)
	local spec = GetSpecialization()
	MSS_ComboTimer:Hide()
	if  spec == 2 or GetShapeshiftFormID() == 1 then -- Feral spec or Cat form
		local pts = GetComboPoints("player", "target")
		local spec = 2
		if pts == 0 then
			SetCombo(spec, MSS_Combo1, false)
			SetCombo(spec, MSS_Combo2, false)
			SetCombo(spec, MSS_Combo3, false)
			SetCombo(spec, MSS_Combo4, false)
			SetCombo(spec, MSS_Combo5, false)			
		elseif pts == 1 then
			SetCombo(spec, MSS_Combo1, true)
			SetCombo(spec, MSS_Combo2, false)
			SetCombo(spec, MSS_Combo3, false)
			SetCombo(spec, MSS_Combo4, false)
			SetCombo(spec, MSS_Combo5, false)		
		elseif pts == 2 then
			SetCombo(spec, MSS_Combo1, true)
			SetCombo(spec, MSS_Combo2, true)
			SetCombo(spec, MSS_Combo3, false)
			SetCombo(spec, MSS_Combo4, false)
			SetCombo(spec, MSS_Combo5, false)		
		elseif pts == 3 then
			SetCombo(spec, MSS_Combo1, true)
			SetCombo(spec, MSS_Combo2, true)
			SetCombo(spec, MSS_Combo3, true)
			SetCombo(spec, MSS_Combo4, false)
			SetCombo(spec, MSS_Combo5, false)		
		elseif pts == 4 then
			SetCombo(spec, MSS_Combo1, true)
			SetCombo(spec, MSS_Combo2, true)
			SetCombo(spec, MSS_Combo3, true)
			SetCombo(spec, MSS_Combo4, true)
			SetCombo(spec, MSS_Combo5, false)
		elseif pts == 5 then
			SetCombo(spec, MSS_Combo1, true)
			SetCombo(spec, MSS_Combo2, true)
			SetCombo(spec, MSS_Combo3, true)
			SetCombo(spec, MSS_Combo4, true)
			SetCombo(spec, MSS_Combo5, true)
		end
	elseif spec == 3 then -- Bear
		local pts, maxCharges, timeLastCast, cooldownDuration  = GetSpellCharges(62606)
		local left = cooldownDuration - GetTime() + timeLastCast
		MSS_ComboTimer:SetText(string.format("%d", left))
		MSS_ComboTimer:Show()
		local _, _, _, powerCost = GetSpellInfo(62606) 
		local low = UnitPower("player", SPELL_POWER_RAGE) < powerCost
		if pts == 0 then		
			MSS_ComboTimer:SetPoint("CENTER", MSS_Combo3, "CENTER",1,2)
			SetCombo(spec, MSS_Combo3, false, low)
			SetCombo(spec, MSS_Combo4, false, low)
			SetCombo(spec, MSS_Combo5, false, low)			
		elseif pts == 1 then			
			MSS_ComboTimer:SetPoint("CENTER", MSS_Combo4, "CENTER",1,2)
			SetCombo(spec, MSS_Combo3, true, low)
			SetCombo(spec, MSS_Combo4, false, low)
			SetCombo(spec, MSS_Combo5, false, low)		
		elseif pts == 2 then			
			MSS_ComboTimer:SetPoint("CENTER", MSS_Combo5, "CENTER",1,2)
			SetCombo(spec, MSS_Combo3, true, low)
			SetCombo(spec, MSS_Combo4, true, low)
			SetCombo(spec, MSS_Combo5, false, low)		
		elseif pts == 3 then			
			MSS_ComboTimer:Hide()
			SetCombo(spec, MSS_Combo3, true, low)
			SetCombo(spec, MSS_Combo4, true, low)
			SetCombo(spec, MSS_Combo5, true, low)	
		end	
	elseif spec == 1 or spec == 4 then -- moonkin mushroom
		local pts = 0
		local i
		for i = 1,3 do
			local haveTotem, _, _, _, _ = GetTotemInfo(i)
			if haveTotem then 
				pts = pts + 1
			end
		end
		local start1, _,_ = GetSpellCooldown(88751)
		local start2, _,_ = GetSpellCooldown(102791)
		local inCD = start1 ~= 0 or start2 ~= 0
		if pts == 0 then			
			SetCombo(spec, MSS_Combo3, false, inCD)
			SetCombo(spec, MSS_Combo4, false, inCD)
			SetCombo(spec, MSS_Combo5, false)			
		elseif pts == 1 then			
			SetCombo(spec, MSS_Combo3, true, inCD)
			SetCombo(spec, MSS_Combo4, false, inCD)
			SetCombo(spec, MSS_Combo5, false, inCD)		
		elseif pts == 2 then			
			SetCombo(spec, MSS_Combo3, true, inCD)
			SetCombo(spec, MSS_Combo4, true, inCD)
			SetCombo(spec, MSS_Combo5, false, inCD)		
		elseif pts == 3 then			
			SetCombo(spec, MSS_Combo3, true,inCD)
			SetCombo(spec, MSS_Combo4, true,inCD)
			SetCombo(spec, MSS_Combo5, true,inCD)	
		end
	end
end


-- Set comboBar to match current spec or form
function ResetComboBar()
	local spec = GetSpecialization()
	if spec == 2 then
		MSS_ComboBorder1:Show()
		MSS_ComboBorder2:Show()
		MSS_Combo1:Show()
		MSS_Combo2:Show()
	else 
		local form = GetShapeshiftFormID()
		if form == 1 then
			MSS_ComboBorder1:Show()
			MSS_ComboBorder2:Show()
			MSS_Combo1:Show()
			MSS_Combo2:Show()
		else 
			MSS_ComboBorder1:Hide()
			MSS_ComboBorder2:Hide()
			MSS_Combo1:Hide()
			MSS_Combo2:Hide()
		end	
	end
end 

-- Primary buff bar
--Primary buffs for each specialization
SPEC_BUFF_LIST = {16886, 127538, 62606, 100977}

function SetupPrimaryBuffIcon(specId)
	local name, _, icon = GetSpellInfo(SPEC_BUFF_LIST[specId])
	MSS_PrimaryBuffBar.portrait:SetTexture(icon)
end

function MSS_PrimaryBuffBar_OnUpdate(self, elapsed)
	self.total = self.total + elapsed	
	if self.total >= .1 then		
		self.total = 0
		
			local spellName = GetSpellInfo(SPEC_BUFF_LIST[GetSpecialization()])			
			local name, rank, icon, count, dispelType, duration, expires = UnitBuff("player", spellName)
			if name ~= nil then
				self.statusBar:SetValue(expires - GetTime())
				self.statusBar.durationText:SetText(string.format("%.1f", self.statusBar:GetValue()))
			else
				self.statusBar:SetValue(0)
				self.statusBar.durationText:SetText("")
			end
		
		if GetSpecialization() == 3 then
			self.statusBar.trackerText:SetText(string.format("%.1f",GetDodgeChance()).."%")
		end
	end	
end




-- Debuff
local DEBUFF_LIST = {
	{nil, nil, 93402,8921}, --Moonkin
	{106830, 113746, 1822, 1079}, --Cat
	{nil, 113746, 33745, 77758}, --Bear
	{nil, nil, 33763, 774} --Resto
}

--Cast-when-ready Abilities
local BUFF1_LIST = {
	{78674, 48505, nil, nil}, --Moonkin
	{5217, nil, nil, nil}, --Cat
	{33878, nil, nil, nil}, --Bear
	{18562, 48438, nil, nil} -- resto
}

--Long-cd abilities
-- 124974 nature vigil
local BUFF2_LIST = {
	{112071, 102560, nil, nil}, --Moonkin
	{106952, 102543, nil, nil}, --Cat
	{106952, 102558, nil, nil}, --Bear
	{740,    117679, nil, nil} --resto
}

function MSS_AuraSlot_OnUpdate(self, elapsed)
	if not MSS_SavedOptions['hide_cooldown_text'] then
		MSS_SavedOptions['hide_cooldown_text'] = false
	end	
	local hideCooldownText = MSS_SavedOptions['hide_cooldown_text']	
	
	if self.spellId then
		local spellName = GetSpellInfo(self.spellId)		
		self.bg:SetTexture(select(3, GetSpellInfo(self.spellId)))
		
		if self.isDebuff then -- Debuff
			local spec = GetSpecialization()
			local filter = "HARMFUL"
			if spec == 4 then
				filter = "HELPFUL"
			end
			local name, rank, icon, count, dispelType, duration, expires, caster = UnitAura("target", spellName, nil, filter)
			if name ~= nil and (self.ignoreCaster or caster == "player") then -- active on target				
				if count > 0 then
					self.countText:SetText(count)
				else 
					self.countText:SetText("")
				end
				self.cooldown:SetReverse(true)
				self.cooldown:SetCooldown(expires - duration, duration)
				self.bg:SetAlpha(1.0)
                
				if not hideCooldownText then
					local leftTime = format("%d", expires - GetTime())
					if expires - GetTime() >= 3 then
						self.text:SetTextColor(0,1,0)
					else 
						self.text:SetTextColor(1,0,0)
					end
					self.text:SetText(leftTime)
					self.text:Show()
				end
			else -- not on target
				self.countText:SetText("")
				self.bg:SetAlpha(0.5)
				self.text:Hide()
				self.cooldown:SetCooldown(0,0)
			end
		else -- Buff 	
			local name, rank, icon, count, dispelType, duration, expires = UnitAura("player", spellName)
			if name ~= nil then --active
				self.bg:SetAlpha(1.0)				
				local leftTime = format("%d", expires - GetTime())			
				self.text:SetTextColor(0,1,0)			
				self.text:SetText(leftTime)
				self.text:Show()
			else 
				local start, duration, enable = GetSpellCooldown(self.spellId)
				self.cooldown:SetCooldown(start, duration)
				if start ~= 0 and duration > 1.5 then --In CD					
					self.bg:SetAlpha(0.5)
					if not hideCooldownText then
						self.text:SetTextColor(1,0,0)
						local leftTime = duration - GetTime() + start
						local t
						self.text:SetFontObject("PVPInfoTextFont")
						if leftTime >= 60 then
							self.text:SetFontObject("NumberFont_Shadow_Small")
							t = format("%d", leftTime/60) .. ":" .. format("%02d", leftTime%60)
						elseif leftTime >= 1 then
							t = format("%d", leftTime)
						elseif leftTime >0 then
							t = format("%.1f", leftTime)	
						end
						self.text:Show()
						self.text:SetText(t )
					else 
						self.text:Hide()
					end
					if self.glowWhenReady and self.glow.playing == 1 then
						self.glow:Hide()
						self.glow.animIn:Stop()
						self.glow.playing = 0
					end
				else -- CD ready
					self.bg:SetAlpha(1)
					self.text:Hide()
					if self.glowWhenReady and self.glow.playing == 0 then
						self.glow:Show()
						self.glow.animIn:Play()
						self.glow.playing = 1
					end
				end			
			end		
		end
	else
		self:Hide()
	end
end


-- Setup aura icons
-- Provoked when player change specialization or talent
function SetupAura(spec)
	if spec == 1 or spec == 2 or spec == 3 or spec == 4 then
		for i = 1, 4 do
			_G["MSS_BuffFrame1_Slot"..i].spellId = BUFF1_LIST[spec][i]			
			_G["MSS_BuffFrame1_Slot"..i].isDebuff = false 
			_G["MSS_BuffFrame1_Slot"..i].glowWhenReady = true	
			_G["MSS_BuffFrame1_Slot"..i]:SetAttribute("spell", GetSpellInfo(BUFF1_LIST[spec][i]))
			
			_G["MSS_BuffFrame2_Slot"..i].spellId = BUFF2_LIST[spec][i]
			_G["MSS_BuffFrame2_Slot"..i].isDebuff = false
			_G["MSS_BuffFrame2_Slot"..i].glowWhenReady = false		
			_G["MSS_BuffFrame2_Slot"..i]:SetAttribute("spell", GetSpellInfo(BUFF2_LIST[spec][i]))
			
			_G["MSS_DebuffFrame_Slot"..i].spellId = DEBUFF_LIST[spec][i]
			_G["MSS_DebuffFrame_Slot"..i].isDebuff = true
			_G["MSS_DebuffFrame_Slot"..i].glowWhenReady = false
			_G["MSS_DebuffFrame_Slot"..i]:SetAttribute("spell", GetSpellInfo(DEBUFF_LIST[spec][i]))
		end
		--TODO
		MSS_DebuffFrame_Slot2.ignoreCaster = true
		MSS_DebuffFrame_Slot2:SetAttribute("spell", GetSpellInfo(770))
		
		local isFree, index = GetTalentRowSelectionInfo(4)
		if isFree or index ~= 11 then
			MSS_BuffFrame2_Slot2.spellId = nil
		end
		
		isFree, index = GetTalentRowSelectionInfo(6)
		local talent6 = nil
		if index == 18 then 
			talent6 = 124974
		elseif index == 16 then
			talent6 = 108288
		end
		if index ~= nil and not isFree then
			if MSS_BuffFrame2_Slot2.spellId == nil then
				MSS_BuffFrame2_Slot2.spellId = talent6
				MSS_BuffFrame2_Slot2:SetAttribute("spell", talent6)
				MSS_BuffFrame2_Slot2.isDebuff = false
				MSS_BuffFrame2_Slot2.glowWhenReady = false
			else 
				MSS_BuffFrame2_Slot3.spellId = talent6 
				MSS_BuffFrame2_Slot3:SetAttribute("spell", talent6)
				MSS_BuffFrame2_Slot3.isDebuff = false
				MSS_BuffFrame2_Slot3.glowWhenReady = false
			end
		end
		
		
		for i = 1, 4 do
			if _G["MSS_BuffFrame1_Slot"..i].spellId ~= nil then
				_G["MSS_BuffFrame1_Slot"..i]:Show()
			end
			if _G["MSS_BuffFrame2_Slot"..i].spellId ~= nil then
				_G["MSS_BuffFrame2_Slot"..i]:Show()
			end
			if _G["MSS_DebuffFrame_Slot"..i].spellId ~= nil then
				_G["MSS_DebuffFrame_Slot"..i]:Show()
			end			
			
		end
		

	end
end


-- Portrait icons for each specialization
SPEC_PORTRAITS_LIST = {	
	"Interface\\ICONS\\Ability_Druid_OwlkinFrenzy.blp",
	"Interface\\ICONS\\INV_Staff_99.blp",
	"Interface\\ICONS\\ABILITY_DRUID_DEMORALIZINGROAR.blp",
	"Interface\\ICONS\\Ability_Druid_NaturalPerfection.blp"
}

SPEC_PORTRAITS_LIST_UNFORM = {
	"Interface\\ICONS\\INV_MISC_PETMOONKINNE.blp",
	"Interface\\ICONS\\Achievement_Halloween_Cat_01.blp",
	"Interface\\ICONS\\inv_misc_bearcubbrown.blp",
	"Interface\\ICONS\\Ability_Druid_NaturalPerfection.blp"
}

-- Update player portrait icon
function UpdatePortrait() 
	if UnitIsDeadOrGhost("player") == 1 then
		MSS_Portrait:SetTexture("Interface\\ICONS\\INV_MISC_FOOD_15.blp")
	elseif GetSpecialization() == nil then
		MSS_Portrait:SetTexture("Interface\\ICONS\\INV_Misc_QuestionMark")
	else
		if GetShapeshiftFormID() == nil then
			MSS_Portrait:SetTexture(SPEC_PORTRAITS_LIST_UNFORM[GetSpecialization()])
		else			
			if (GetSpecialization() == 1 and GetShapeshiftFormID() == 31) or (GetSpecialization() == 2 and GetShapeshiftFormID() == 1) or (GetSpecialization() == 3 and GetShapeshiftFormID() == 5) then
				MSS_Portrait:SetTexture(SPEC_PORTRAITS_LIST[GetSpecialization()])
			else
				MSS_Portrait:SetTexture(SPEC_PORTRAITS_LIST_UNFORM[GetSpecialization()])
			end
		end
	end
end 



-- Setup frame after changing specialization
function MSS_OnChangeSpecialization()
	local SPEC_ID = GetSpecialization()	
	
	MSS.powerFrame.RageBar:Hide()
	MSS.powerFrame.EnergyBar:Hide()
	MSS.powerFrame.ManaBar:Hide()
	MSS.powerFrame.EclipseBar:Hide()
	
	ResetComboBar()
	MSS_ComboFrame:Show()
	
	SetupAura(SPEC_ID)	
	SetupPrimaryBuffIcon(SPEC_ID)
	
	MSS_Portrait:SetTexture(SPEC_PORTRAITS_LIST_UNFORM[SPEC_ID])
	
	
	ManaBar_OnLoad(MSS.powerFrame.ManaBar)
	
	if SPEC_ID == 1 then --Monnkin
		MSS.powerFrame.EclipseBar:Show()
		MSS_PrimaryBuffBar.statusBar:SetMinMaxValues(0,18)
		MSS_PrimaryBuffBar.statusBar:SetValue(0)
	    MSS_PrimaryBuffBar.statusBar:SetStatusBarColor(0.13,0.93,0)
		MSS_PrimaryBuffBar.statusBar.trackerText:Hide()
		
	elseif SPEC_ID == 2 then --Cat
		MSS.powerFrame.EnergyBar:Show()	
		MSS_PrimaryBuffBar.statusBar:SetMinMaxValues(0,45)
		MSS_PrimaryBuffBar.statusBar:SetValue(0)
	    MSS_PrimaryBuffBar.statusBar:SetStatusBarColor(0.75,0,0)
		MSS_PrimaryBuffBar.statusBar.trackerText:Hide()
		
	elseif SPEC_ID == 3 then --Bear
		MSS.powerFrame.RageBar:Show()
		MSS_PrimaryBuffBar.statusBar:SetMinMaxValues(0,18)
		MSS_PrimaryBuffBar.statusBar:SetValue(0)
	    MSS_PrimaryBuffBar.statusBar:SetStatusBarColor(0.73,0.73,0)
		MSS_PrimaryBuffBar.statusBar.trackerText:Show()
	elseif SPEC_ID == 4 then --Tree
		MSS.powerFrame.ManaBar:Show()
		MSS_PrimaryBuffBar.statusBar:SetMinMaxValues(0,20)
		MSS_PrimaryBuffBar.statusBar:SetValue(0)
	    MSS_PrimaryBuffBar.statusBar:SetStatusBarColor(0.93,0.93,0)
		MSS_PrimaryBuffBar.statusBar.trackerText:Hide()
	end	
end

function MSS_OnChangeForm()	
	ResetComboBar()
	if MSS_SavedOptions["switch_on_shapeshift"] then
		MSS.powerFrame.RageBar:Hide()
		MSS.powerFrame.EnergyBar:Hide()
		MSS.powerFrame.ManaBar:Hide()
		MSS.powerFrame.EclipseBar:Hide()
		local formId = GetShapeshiftFormID()
		local specId = GetSpecialization()
		if formId == 5 then
			MSS.powerFrame.RageBar:Show()
		elseif formId == 1 then
			MSS.powerFrame.EnergyBar:Show()
		elseif formId == 31 then --moonkin
			MSS.powerFrame.EclipseBar:Show()
		else
			if specId == 1 then
				MSS.powerFrame.EclipseBar:Show()
			else 
				MSS.powerFrame.ManaBar:Show()
			end
		end
	end
end


function MSS_OnEvent(self, event, ...)
	if event == "PLAYER_SPECIALIZATION_CHANGED" or event == "PLAYER_ENTERING_WORLD" then
		MSS_OnChangeSpecialization()
		MSS_OnChangeForm()			
	elseif event == "PLAYER_REGEN_DISABLED" then -- Enter combat		
		if MSS_SavedOptions["enable_mss"] and MSS_SavedOptions["hide_out_of_combat"] then
			self:Show()
			MSS_Mask:Show()
		end
	elseif event == "PLAYER_REGEN_ENABLED" then -- Leave combat
		if MSS_SavedOptions["enable_mss"] and MSS_SavedOptions["hide_out_of_combat"] then
			self:Hide()
			MSS_Mask:Hide()
		end
	elseif event == "UPDATE_SHAPESHIFT_FORM" then
		MSS_OnChangeForm()
	elseif event == "PET_BATTLE_OPENING_START" or event == "UNIT_ENTERING_VEHICLE" then
		self:SetAlpha(0.0)		
		MSS_Mask:SetAlpha(0.0)
	elseif event == "PET_BATTLE_CLOSE" or event == "UNIT_EXITING_VEHICLE" then
		self:SetAlpha(1.0)
		MSS_Mask:SetAlpha(1.0)		
	end
end


function MSS_OnUpdate(self, elapsed)
	self.updateTimer = self.updateTimer + elapsed
	if self.updateTimer > 0.5 then
		self.updateTimer = 0
		UpdatePortrait()
	end
end


function MSS_FloatAlert_OnUpdate(self, elapsed, spellId)
	local n = GetSpellInfo(spellId)
	local name, rank, icon, count, dispelType, duration, expires, _, _, _, id = UnitBuff("player", n)
		
	if not MSS_SavedOptions["lock_float_alert"] then
			self.image:Show()
	elseif name ~= nil and spellId == id then
		if self.isPlaying == 0 then
			self.image.pulse:Play()			
			self.isPlaying = 1
		end		
		self.image:Show()
		self.text:SetText(format("%d", expires - GetTime()))
		self.text:Show()
		if count > 0 then
			self.textCount:SetText(count)
			self.textCount:Show()		
		end
	else 
		self.image:Hide()
		self.text:Hide()
		self.textCount:Hide()
	end
end


-- Player HP bar
function MyHpBar_OnUpdate(self, elapsed)
	local maxhp = UnitHealthMax("player")
	local hp = UnitHealth("player")
	self:SetMinMaxValues(0, maxhp)
	
	local baseAP, pos, neg = UnitAttackPower("player")
	local AP = baseAP + pos - neg
	local Agi = UnitStat("player", 2)
	local stamina = UnitStat("player", 3)	
	local modifier = max(2 * (AP - (Agi*2)), stamina * 2.5) 
	
	if UnitPower("player", SPELL_POWER_RAGE) < 60 then
		modifier = modifier * UnitPower("player", SPELL_POWER_RAGE) / 60
	end
	-- print(modifier)
	self:SetValue(hp + (modifier))	
	
	MSS_RealHpBar:SetMinMaxValues(0, maxhp)
	MSS_RealHpBar:SetValue(hp)	
	if hp / maxhp >= 0.25 then
		MSS_RealHpBar:SetStatusBarColor(0,1,0)
	else
		MSS_RealHpBar:SetStatusBarColor(0.8,0,0)
	end
end


-- Target HP bar
function TargetHpBar_OnUpdate(self, elapsed)
	local maxhp = UnitHealthMax("target")
	local hp = UnitHealth("target")
	if maxhp == 0 then
		self:SetAlpha(0)
	else		
		self:SetAlpha(1)
		self:SetMinMaxValues(0, maxhp)
		self:SetValue(hp)
		if hp / maxhp >= 0.8 then
			self:SetStatusBarColor(0, 1, 0)
		elseif hp / maxhp >= 0.25 then
			self:SetStatusBarColor(1,1,0)
		else
			self:SetStatusBarColor(0.8,0,0)
		end
	end
end


