﻿-- Class id Druid: 11

--[[
Spec id DRUID:
Restoration	105
Guardian	104
Feral		103
Balance		102
]]--

local gains = {
	["DEATHKNIGHT"] = {[102] = 110570, [104] = 122285, [103] = 122282, [105] = 110575,}, --DK
	["HUNTER"] = {[102] = 110588, [104] = 110600, [103] = 110597, [105] = 110617,}, --Hunter
	["MAGE"] = {[102] = 110621, [104] = 110694, [103] = 110693, [105] = 110696,}, --Mage
	["MONK"] = {[102] = 126458, [104] = 126453, [103] = 126449, [105] = 126456,}, --Monk
	["PALADIN"] = {[102] = 110698, [104] = 110701, [103] = 110700, [105] = 122288,}, --Paladin
	["PRIEST"] = {[102] = 110707, [104] = 110717, [103] = 110715, [105] = 110718,}, --Priest
	["ROGUE"] = {[102] = 110788, [104] = 122289, [103] = 110730, [105] = 110791,}, --Rogue	
	["SHAMAN"] = {[102] = 110802, [104] = 110803, [103] = 110807, [105] = 110806,}, --Shaman	
	["WARLOCK"] = {[102] = 122291, [104] = 122290, [103] = 110810, [105] = 112970,}, --Warlock
	["WARRIOR"] = {[102] = 122292, [104] = 113002, [103] = 112997, [105] = 113004,} --Warrior
}

local class_spec = {
	["DEATHKNIGHT"] = {250,251,252}, --DK
	["HUNTER"] = {253,254,255}, --Hunter
	["MAGE"] = {62,63,64}, --Mage
	["MONK"] = {268,269,270}, --Monk
	["PALADIN"] = {65,66,70}, --Paladin
	["PRIEST"] = {256,257,258}, --Priest
	["ROGUE"] = {259,260,261}, --Rogue	
	["SHAMAN"] = {262,263,264}, --Shaman	
	["WARLOCK"] = {265,266,267}, --Warlock
	["WARRIOR"] = {71,72,73} --Warrior
}

local gives = {
	[62] = 113074, -- Arcane Mage
	[63] = 113074, -- Fire Mage
	[64] = 113074, -- Frost Mage
	[65] = 113269, -- Holy Paladin
	[66] = 122287, -- Prot Paladin 113075
	[70] = 122287, -- Ret Paladin
	[71] = 122294, -- Arms Warrior
	[72] = 122294, -- Fury Warrior
	[73] = 122294, -- Prot Warrior 122286
	[250] = 113516, -- Blood DK 113072
	[251] = 113516, -- Frost DK
	[252] = 113516, -- Unholy DK
	[253] = 113073, -- BM Hunter
	[254] = 113073, -- Marks Hunter
	[255] = 113073, -- Surv Hunter
	[256] = 113506, -- Disc Priest
	[257] = 113506, -- Holy Priest
	[258] = 113277, -- Shadow Priest
	[259] = 113613, -- Assa Rogue
	[260] = 113613, -- Combat Rogue
	[261] = 113613, -- Sub Rogue
	[262] = 113286, -- Ele Shaman
	[263] = 113286, -- Enh Shaman
	[264] = 113289, -- Resto Shaman
	[265] = 113295, -- Afflic Lock
	[266] = 113295, -- Demo Lock
	[267] = 113295, -- Dest Lock
	[268] = 127361, -- BM Monk 113306
	[269] = 127361, -- WW Monk
	[270] = 113275, -- MW Monk
}

MSS_SymbiosisTooltip = CreateFrame("GameTooltip", "MSS_SymbiosisTooltip", nil, "GameTooltipTemplate")
MSS_SymbiosisTooltip:SetScale(0.8)

--use for retreive spell info
MSS_ScanTip = CreateFrame("GameTooltip", "MSS_ScanTip", nil, "GameTooltipTemplate")
MSS_ScanTip:SetOwner(WorldFrame, "ANCHOR_NONE")

function MSS_SymbiosisFrame_OnLoad(self)	
	for i = 1, GetNumClasses() do
		local classDisplayName, classTag, classID = GetClassInfo(i)
		--print(i.."="..classTag)
		if classTag ~= "DRUID" then			
			local classFrame = CreateFrame("Button", "MSS_Symbiosis_"..classTag, self, "MSS_SymbiosisSpell_T")
			classFrame.bg:SetTexture("Interface\\Glues\\CharacterCreate\\UI-CharacterCreate-Classes")
			classFrame.bg:SetTexCoord(unpack(CLASS_ICON_TCOORDS[classTag]))
			classFrame:SetPoint("TOPLEFT", self, "TOPLEFT", 75+50*(i-1), -30)
			classFrame:SetScript("OnEnter", function(self, button)
					MSS_SymbiosisTooltip:SetOwner(self, "ANCHOR_TOPRIGHT");
					MSS_SymbiosisTooltip:ClearLines()
					local rr = RAID_CLASS_COLORS[classTag]['r']
					local gg = RAID_CLASS_COLORS[classTag]['g']
					local bb = RAID_CLASS_COLORS[classTag]['b']					
					MSS_SymbiosisTooltip:AddLine(classDisplayName, rr, gg, bb, false)
					for k,specId in pairs(class_spec[classTag]) do						
						local id, specName, _, _, _, _, _ = GetSpecializationInfoByID(specId)
						local spellName, _, spellIcon = GetSpellInfo(gives[specId])
						MSS_ScanTip:SetSpellByID(gives[specId])						
						tdesc = "|cFF00FF00" .. _G["MSS_ScanTipTextLeft" .. MSS_ScanTip:NumLines()]:GetText()
						--tdesc = string.gsub(tdesc, "|R", "")						
						MSS_SymbiosisTooltip:AddDoubleLine("|T" .. spellIcon .. ":22|t " .. spellName, specName, 1, 1, 1, 0,1,0)
						MSS_SymbiosisTooltip:AddLine(tdesc, nil, nil, nil, true)
					end
					MSS_SymbiosisTooltip:Show()
				end
			)
			classFrame:SetScript("OnLeave", function(self, button)						
				MSS_SymbiosisTooltip:Hide()
			end
			)
			
			for spec = 102, 105 do
				local spellId = gains[classTag][spec]
				local frame = CreateFrame("Button", "MSS_Symbiosis_"..i.."_"..spec, self, "MSS_SymbiosisSpell_T")
				local name, rank, icon = GetSpellInfo(spellId)
				frame.bg:SetTexture(icon)
				frame:SetPoint("TOP", classFrame, "BOTTOM", 0, -10 - 60*(spec - 102))		
				--print(frame:GetName())
				frame:SetScript("OnClick", function(self, button)
					local link, _ = GetSpellLink(spellId)
					print(L["you_gain"]..link)
					local str = ""
					for k,specId in pairs(class_spec[classTag]) do
						local link, _ = GetSpellLink(gives[specId])
						local id, name, _, _, _, _, _ = GetSpecializationInfoByID(specId)
						str = str..name..":"..link..""
					end
					print(L["you_give"].." "..classDisplayName)
					print(str)
				end
				)
				frame:SetScript("OnEnter", function(self, button)
					MSS_SymbiosisTooltip:SetOwner(self, "ANCHOR_TOPRIGHT");
					MSS_SymbiosisTooltip:ClearLines()
					MSS_SymbiosisTooltip:SetSpellByID(spellId)
				end
				)
				frame:SetScript("OnLeave", function(self, button)						
					MSS_SymbiosisTooltip:Hide()
				end
				)
			end
		end
	end
end

ShowMsg("Symbiosis Loaded...")