﻿local WILD_CHARGE_SPELL_ID = {
	[1] = 49376,
	[3] = 102417,
	[4] = 102416,
	[5] = 16979,
	[31] = 102383
}

local MSS_TalentTooltip = CreateFrame("GameTooltip", "MSS_TalentTooltip", nil, "GameTooltipTemplate")
MSS_TalentTooltip:SetScale(0.8)
--
-- Provoked when talents are updated
--
function SetTalentActions(self, event)		
		
	if event  ~= "UPDATE_SHAPESHIFT_FORM" then		
		local i
		for i = 1,6 do
			local button = _G["MSS_TalentActionBar_Button"..i]
			button.cooldown:SetCooldown(0,0)
			local isFree, index = GetTalentRowSelectionInfo(i)
			if not isFree then
				local name,icon = GetTalentInfo(index)			
				local mlink, _ = GetSpellLink(name)	
				button.icon:SetTexture(icon)
				if mlink ~= nil then			
					--print(mlink)
					local _, sid = strsplit(":", strmatch(mlink, "spell:%d+"))			
					--print("In "..name.."="..sid)				
					if not IsPassiveSpell(name) or sid == "106707"--[[faeris sworm]] then
								
							if sid == "106707" then	--faeris sworm								
								button:SetAttribute("spell", GetSpellInfo(770));
								button:SetScript("OnUpdate", function(self)
										local start, duration, enable = GetSpellCooldown(102355)
										self.cooldown:SetCooldown(start, duration)
									end
								)
								button:SetScript("OnEnter", function(self)
									MSS_TalentTooltip:SetOwner(self, "ANCHOR_TOPRIGHT");
									MSS_TalentTooltip:ClearLines()
									MSS_TalentTooltip:SetSpellByID(102355)					
									end
								)
							else 
								button:SetAttribute("spell", name);
								button:SetScript("OnUpdate", function(self)
										local start, duration, enable = GetSpellCooldown(name)
										if enable == 1 then
											self.cooldown:SetCooldown(start, duration)
										end
									end
								)
								button:SetScript("OnEnter", function(self)
									MSS_TalentTooltip:SetOwner(self, "ANCHOR_TOPRIGHT");
									MSS_TalentTooltip:ClearLines()
									MSS_TalentTooltip:SetSpellByID(sid)					
									end
								)						
							end						
							
					else -- Passive talent
						button:SetAttribute("spell", "");	
						button:SetScript("OnUpdate", nil)
						button:SetScript("OnEnter", function(self)
									MSS_TalentTooltip:SetOwner(self, "ANCHOR_TOPRIGHT");
									MSS_TalentTooltip:ClearLines()
									MSS_TalentTooltip:SetSpellByID(sid)					
									end
						)						
					end
					button:SetScript("OnLeave", function(self)						
										MSS_TalentTooltip:Hide()
									end
								)
				end
			else -- no talent at tier i
				button:SetAttribute("spell", "");
				button.icon:SetTexture("Interface\\ICONS\\INV_Misc_QuestionMark")
				button:SetScript("OnUpdate", nil)
				button:SetScript("OnEnter", nil)
			end
		end
	end	
	
	local free, ind = GetTalentRowSelectionInfo(1)
	if not free and ind == 3 then -- wild charge selected
		local formId = GetShapeshiftFormID()
		local spellId = WILD_CHARGE_SPELL_ID[formId];			
		if not spellId then				
			local name, icon = GetTalentInfo(3)
			MSS_TalentActionBar_Button1:SetAttribute("spell", name);
			MSS_TalentActionBar_Button1.icon:SetTexture(icon)
		else 						
			local name, _, icon = GetSpellInfo(spellId)
			MSS_TalentActionBar_Button1:SetAttribute("spell", name);
			MSS_TalentActionBar_Button1.icon:SetTexture(icon)
		end
	end
end

function MSS_TalentActionBar_OnLoad(self)
	for i = 1,6 do
		local btn = CreateFrame("Button", "MSS_TalentActionBar_Button"..i, self, "MSS_TalentButton_T");
		btn:SetPoint("LEFT", self, "LEFT", 12 + 37*(i-1), 0)
		btn:SetAttribute("type", "spell");
	end


end

function MSS_TalentActionBar_OnEvent(self, event)
	
	if event == "PET_BATTLE_OPENING_START" or event == "UNIT_ENTERING_VEHICLE" then 
		self:Hide()			
	elseif event == "PET_BATTLE_CLOSE" or event == "UNIT_EXITING_VEHICLE" then
		self:Show()
	else
		SetTalentActions(self, event)	
	end
end

function MSS_TalentActionButton_OnUpdate(self, elapsed)
	for i = 1,6 do
		local button = _G["MSS_TalentActionBar_Button"..i]
		local spellName = button:GetAttribute("spell")
		local inRange = IsSpellInRange(spellName, "target")
		if inRange == 0 then		
			button.hotkey:SetTextColor(1,0,0)			
		else 
			button.hotkey:SetTextColor(1,1,1)
		end
	end	
end

-- binding
BINDING_HEADER_MYDOSTUFF = L["addon_name"];
for i=1,6 do
	_G["BINDING_NAME_CLICK MSS_TalentActionBar_Button"..i..":LeftButton"] = L["talent"]..i
end


ShowMsg("TalentActionBar Loaded...")	


