local function InitOptions_TalentBar(parent)
	parent.talentBar = CreateFrame("Frame", "TalentBar", parent)
	parent.talentBar.name = L["option_title_talentbar"]
	parent.talentBar.parent = parent.name
	parent.talentBar.refresh = function ()
		parent.talentBar.option_lock:SetChecked(MSS_SavedOptions["talentbar_lock"])
	end
	InterfaceOptions_AddCategory(parent.talentBar)

	parent.talentBar.option_lock = MSS_CreateCheckOption(
		parent.talentBar, "left", 1, L["options_lock_talentbar_text"], function()
			OptionCommand_LockTalentBar(parent.talentBar.option_lock:GetChecked())			
		end
	)	
end

function OptionCommand_LockTalentBar(flag)
	MSS_SavedOptions["talentbar_lock"] = flag
	if flag then
		MSS_TalentBar:RegisterForDrag("")
	else
		MSS_TalentBar:RegisterForDrag("LeftButton")
	end
end

function MSS_TalentBar:ApplyOptions(options)
	OptionCommand_LockTalentBar(options["talentbar_lock"])
end


InitOptions_TalentBar(MSS_OptionsPanel)
